<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Character/Wizard.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li><li class="navelem"><a class="el" href="dir_8082b9977330bac1504bd0163637bac5.html">Character</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Wizard.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_wizard_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_character_class_8hpp.html">./CharacterClass.hpp</a>&quot;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;../Object/IObject.hpp&quot;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;../Object/Potion.hpp&quot;</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;{</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html">   35</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_wizard.html">Wizard</a> : <span class="keyword">public</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> <span class="comment">//, enable_shared_from_this&lt;Wizard&gt; //This parts allow to use this as smart pointer (remplace &quot;this&quot; by &quot;shared_from_this()&quot;)</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    {</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#ab046f9df1d49c193033b519e3f63927f">   42</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> DAMAGE_SKILL_FIREBALL{5};</div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a368bfc4fb66c29a4548b19e4a02a54f0">   47</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> RANGE_SKILL_FIREBALL{2};</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#af5e94d149d128977e4dbd3dca644eaff">   53</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> COST_MANA_CAST_SPELL{2};</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#af61dc4150a7316b6abf1d2c9f5cdbf3a">   59</a></span>&#160;        <span class="keyword">const</span> <span class="keywordtype">int</span> REGEN_MANA_AMOUT{1};</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a9c5a8dc13405fea41ddfc8bb0027abad">   65</a></span>&#160;        <span class="keywordtype">int</span> m_mana{0};</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_wizard.html">Wizard</a>(<span class="keywordtype">int</span> level = 1, <span class="keywordtype">int</span> strength = 5, <span class="keywordtype">int</span> agility = 10, <span class="keywordtype">int</span> intelligence = 15, <span class="keywordtype">int</span> perception = 10, <span class="keywordtype">double</span> hp = 10, <span class="keywordtype">string</span> name = <span class="stringliteral">&quot;no_name&quot;</span>, <span class="keywordtype">int</span> mana = 10, shared_ptr&lt;IObject&gt; <span class="keywordtype">object</span> = make_shared&lt;Potion&gt;(<a class="code" href="class_he___arc_1_1_r_p_g_1_1_potion.html">Potion</a>{<span class="stringliteral">&quot;Normal Potion&quot;</span>, 4}));</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keyword">virtual</span> ~Wizard() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keyword">virtual</span> Wizard *Clone() <span class="keyword">const override</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">string</span> GetClassTypeName() <span class="keyword">const override</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordtype">void</span> Show() <span class="keyword">const override</span>;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keywordtype">void</span> Interact(<span class="keyword">const</span> CharacterClass &amp;character) <span class="keyword">const override</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a1f4e7c257f5445fca073a3aeb512512f">  111</a></span>&#160;        <span class="keywordtype">int</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a1f4e7c257f5445fca073a3aeb512512f">GetMana</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> UseSkill(<a class="code" href="class_he___arc_1_1_r_p_g_1_1_character_class.html">CharacterClass</a> *target = <span class="keyword">nullptr</span>) <span class="keyword">override</span>; <span class="comment">// * allows to be nullable instead of &amp;</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> RegenMana();</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    };</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="ttc" id="a_character_class_8hpp_html"><div class="ttname"><a href="_character_class_8hpp.html">CharacterClass.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;CharacterClass.cpp&quot;</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_character_class_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_character_class.html">He_Arc::RPG::CharacterClass</a></div><div class="ttdoc">Class for the CharacterClass. A character class is the &quot;type&quot; (the class) of a character,...</div><div class="ttdef"><b>Definition:</b> CharacterClass.hpp:39</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_potion_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_potion.html">He_Arc::RPG::Potion</a></div><div class="ttdoc">Class for the potions, contains the stats and capacity of a potion.</div><div class="ttdef"><b>Definition:</b> Potion.hpp:34</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_wizard_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_wizard.html">He_Arc::RPG::Wizard</a></div><div class="ttdoc">Class for the Wizard, a class of character (CharacterClass specialisation) The wizards have the abili...</div><div class="ttdef"><b>Definition:</b> Wizard.hpp:36</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_wizard_html_a1f4e7c257f5445fca073a3aeb512512f"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_wizard.html#a1f4e7c257f5445fca073a3aeb512512f">He_Arc::RPG::Wizard::GetMana</a></div><div class="ttdeci">int GetMana() const</div><div class="ttdoc">Get the mana of the character.</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
